#include <iostream>
#include <fstream>
using namespace std;

void divide(int a, int b, int& q, int& r);
void dividePtrsVersion(int a, int b, int* pq , int* pr);
void rotateThree(int &a, int &b, int &c);
void rotateThreePtrsVersion(int *pa, int* pb, int* pc);
void fileStatistics(char* name, int &numberOfCharacters, int &numberOfWords, int &numberOfLines);

void main(){
	//test divide
	int q, r;
	
	cout << "Function divide :" << endl;
	divide(23,7,q,r);
	cout << "The quotient of 23/7 is "  << q << " and the remainder is " << r << endl;
	cout << "Function dividePtrsVersion :" << endl;
	dividePtrsVersion(21,5,&q,&r);
	cout << "The quotient of 21/5 is "  << q << " and the remainder is " << r << endl;
	cout << "Before calling rotateThree :" << endl;
	int a = 2;
	int b = 5;
	int c = 7;
	cout << "a = " << a << " b = " << b << " c = " << c << endl;
	rotateThree(a,b,c);
	cout << "After calling rotateThree :" << endl;
	cout << "a = " << a << " b = " << b << " c = " << c << endl;
	a = 2;
	b = 5;
	c = 7;
	cout << "Before calling rotateThreePtrsVersion :" << endl;
	cout << "a = " << a << " b = " << b << " c = " << c << endl;
	rotateThreePtrsVersion(&a,&b,&c);
	cout << "After calling rotateThreePtrsVersion :" << endl;
	cout << "a = " << a << " b = " << b << " c = " << c << endl;

	cout << "Testing fileStatistics " << endl;
	int nC,nW,nL; //number of characters, number of words, number of Lines.
	fileStatistics("Prob4.cpp",nC,nW,nL);
	cout << "The number of characters is : " <<  nC << endl;
	cout << "The number of lines is : " << nL << endl;
	cout << "The number of words is : " << nW << endl;
}

void divide(int a , int b, int& q, int& r){
	//assumes a>=0 , b > 0
	q = a/b;
	r = a%b;
}
void dividePtrsVersion(int a, int b, int* pq, int* pr){
	*pq = a/b;
	*pr = a%b;
}
void rotateThree(int& a, int& b, int& c){
	int temp = c;
	c = b;
	b = a;
	a = temp;
}
void rotateThreePtrsVersion(int *pa, int* pb, int* pc){
	int temp = *pc;
	*pc = *pb;
	*pb = *pa;
	*pa = temp; 
}



void fileStatistics(char* filename, int &charcount, int &wordcount, int &linecount)
{
	
	ifstream infile;
	infile.open(filename);
	if(!infile)
			cout << "Cannot open file!"<<endl;			
    else {

		charcount=0;
		linecount=0;
		char c;
		infile.get(c);
		while(!infile.eof()){	
			charcount ++;
			if(c=='\n')	linecount++;
			infile.get(c);			
		}
		if(charcount!=0)  
		   linecount = linecount + 1;
		infile.close();
		infile.clear();
		infile.open(filename);
		char singleword[1000]="";
		wordcount =0;
		infile >> singleword; 

		if(strlen(singleword)!=0) 	wordcount++; 
		while(!infile.eof())
		{
			infile >> singleword;
			wordcount++;
		}	

	}

};


