#include <iostream>
using namespace std;

int partition(int *,int);
void swap(int &,int &);
void  printArray(const int *,int);


void main()
{
	int A[]= {14,2, 11,13,6,5,15,9,8, 12, 3, 10, 4, 1, 7};
	cout<<"orginal array:"<<endl;
	printArray(A,15);
	int q = partition(A,15);
	cout<<"after calling partition:"<<endl;
    printArray(A,15);
	cout<<"q="<<q<<endl;
}


int partition(int *A,int n)
{
    int i=0;
	if(n<=1) return 0;
    int j=n-2;
    while (i<j) {
      	while (A[i]<=A[n-1] && i<j)
	    	i++;
	    while (A[j]>=A[n-1] && i<j)
		    j--;
		swap(A[i],A[j]);
    }
	//When the loop exits, we have i=j. Exactly one of three cases must hold:
	//1-A[i]>A[n-1]
	//2-A[i]= A[n-1]
	//3-A[i]<A[n-1] 
	//In the first 2 cases, we can just swap A[i] with A[n-1], and we're done.
	//In the last case, since we have i=j, and since at any time A[j+1]>=A[n-1],
	//we can swap A[j+1] with A[n-1] (A[j+1] is not out of bounds, since the maximum
	//value of j is n-2)
	
   
	if(A[i]>=A[n-1])  {
		swap(A[i],A[n-1]);
		return i; 
	}
	else {
		swap(A[i+1],A[n-1]);
		return i+1;
	}

}


void swap(int&x,int&y)
{
	int temp=x;
	x=y;
	y=temp;
}


void printArray(const int *A,int n)
{
	for (int i=0;i<n;i++) 
		cout<<A[i]<<" ";
	cout<<endl;
}
